<?

//======================================
// get permission
//======================================

function get_perms($file) {
   $p_bin = substr(decbin(fileperms($file)), -9) ;
   $p_arr = explode(".", substr(chunk_split($p_bin, 1,"."), 0, 17)) ;
   $perms = ""; $i = 0;
   foreach ($p_arr as $this) { 
      $p_char = ( $i%3==0 ? "r" : ( $i%3==1 ? "w" :"x" ) ); 
      $perms .= ( $this=="1" ? $p_char : "-" ) . ($i%3==2 ? " " : "" );
      $i++;
   }
   return $perms;
}

//======================================
// File size check
//======================================

function size_cut($string,$dotpo=1) {
	if ($string>102.4 && $string <102400) 
	$msg_size = number_format(($string/1024),$dotpo)."K";
	else if ($string>=102400) 
	$msg_size = number_format(($string/1024000),$dotpo)."M";
	else 
	$msg_size = $string;
	return $msg_size;
}


//======================================
// Long text cut
//======================================

function text_cut($sub, $max) { 

$count = strlen($sub);
	if($count >= $max) { 
		for ($pos=$max;$pos>0 && ord($sub[$pos-1])>=127;$pos--); 
		if (($max-$pos)%2 == 0) 
		$sub = substr($sub, 0, $max)." ..."; 
		else 
		$sub = substr($sub, 0, $max+1)." ..."; 
	} 

return $sub;
}


//======================================
// htmlspecialchars
//======================================

function htmlspecial($string) {
//$string = str_replace("&","&amp;",$string);
//$string = str_replace("\"","&quot;",$string);
//$string = str_replace("\'","&#039;",$string);
$string = str_replace("<","&lt;",$string);
$string = str_replace(">","&gt;",$string);
return $string;
}

//======================================
// check email address
//======================================

function check_email($email) {

if (!eregi("^[_a-z0-9]+(\.[a-z0-9\-_]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
return false;
}
return $email;
}

//======================================
// Error message
//======================================

function errmsg($string) {
echo "<script> alert('$string');  history.back(); </script> "; exit;
}

function maxnum($table, $column) {
global $db;

$db->query("select MAX($column) as maxnum from $table");
if ($db->numrow>0) 
$max_row = $db->nrecord();
return $max_row[maxnum] + 1 ;

}

//======================================
// Operation time check
//======================================

function check_time($time1) {

$time2 = microtime(); 
$time1 = strchr($time1," ") .".". substr($time1 , 2,strpos($time1," ")-2); 
$time2 = strchr($time2," ") . "." . substr($time2 , 2,strpos($time2," ")-2); 

 $time = $time2 - $time1;
 echo "<br><br><hr size=1 color=#CCCCCC align=left width=100%>
<font size=2>$time</font>";

}


//======================================
// add http://
//======================================

function add_http($url)
{

    $url = ereg_replace("^http.*://", "", $url);
    $url = ereg_replace("^", "http://", $url);

    return $url;
}


//======================================
// Make category select box
//======================================

function view_category($return="",$relateview="",$compare="",$add_link="") 
{
global $db, $Ssepchar,$Sarrow;
	
	if (!$return) $return = "sid";
	
	if ($relateview) $add_query = "where relate<1";
	if ($add_link) $add_query = "where c_link ='1'";

	$db->query("select $return,pathtxt,relate from LINKER_CAT $add_query  order by pathtxt");

	for ($i=0 ; $i < $db->numrow ; $i++) 	{
	$view_row = $db->nrecord();
	$view_row[pathtxt] = str_replace($Ssepchar, $Sarrow , $view_row[pathtxt]);
	if ($compare && $view_row[$return]==$compare) 
	$view_cat .="<option value='$view_row[$return]' selected>$view_row[pathtxt]</option>\n";
	else
	$view_cat .="<option value='$view_row[$return]'>$view_row[pathtxt]</option>\n";
	}

return  $view_cat;
}


//======================================
// Make menu bar
//======================================

function show_menu($sid="") {

global  $tpl,$Sdomain,$l_m_array;

$tpl->define(	array( menubar => "menu_bar.html" ) );
	
$tpl->assign( array(
L_M_ADD =>$l_m_array[add],
L_M_NEWS =>$l_m_array[news],
L_M_COOL =>$l_m_array[cool],
L_M_PICK =>$l_m_array[pick],
L_M_TKWORD =>$l_m_array[tkword],
L_M_ESEARCH =>$l_m_array[esearch],
L_M_TREE =>$l_m_array[tree],
ADD_HREF	 =>"$Sdomain/add.php?sid=$sid"
));

$tpl->parse(MENU_BAR, "menubar");
$tpl->clear(array("L_M_ADD","L_M_NEWS","L_M_COOL","L_M_PICK",
"L_M_TKWORD","L_M_ESEARCH","L_M_TREE","ADD_HREF"));
}

//======================================
// Get Location 
//======================================

function show_here($path="", $ext="", $title = "" )
{
	global  $Ssepchar, $Sarrow, $tpl;
	
	if (!$title) {
	$tpl->define(	array( here	 => "here.html" ) );
	$tpl->dyn_define( "row" , "here" );
	$path_ar = explode("/",$path);
	$ext_ar = explode($Ssepchar,$ext);
	$tpl->assign(array( SEPTER => $Sarrow ));

		for ($i=0 ; $i <count($path_ar) ; $i++) 
		{
			$tpl->assign(	array(
			HE_CAT		=>$path_ar[$i],
			HE_TITLE	=>	$ext_ar[$i]
			));
			
			$tpl->parse(HERE_ROW,".row");
		}	
	}
	else {
	$tpl->define(	array( here => "here_static.html" ) );
	$tpl->assign( array( HE_TITLE => $title ));
	}
	
	$tpl->parse(HERE, "here");
	$tpl->clear(array("HERE_ROW", "HE_CAT" , "HE_TITLE"));
	$tpl->dyn_clear("row");

}

//======================================
// Get search bar
//======================================

function show_search($catview="",$select="") {

global  $tpl, $l_cat,$l_count,$l_all_cat,$l_this_cat,$l_search,$total_row,$cat_count,$cat_path;

$tpl->define( array( searchbar => "search_bar.html" ));
$tpl->dyn_define("serow1","searchbar");
$tpl->dyn_define("serow2","searchbar");

if ($catview) {

$tpl->assign(array(
L_CAT			=> $l_cat,
L_COUNT		=> $l_count,
CATANUM		=> $total_row ,
COUNT			=> $cat_count
));
$tpl->parse("SROW1","serow1");
}

if ($select) {
$tpl->assign(array(
CATPATH		=> $cat_path,
L_ALL_CAT		=> $l_all_cat,
L_THIS_CAT	=> $l_this_cat
));
$tpl->parse("SROW2","serow2");
}

$tpl->assign(array(L_SEARCH	=> $l_search ));

$tpl->parse(SEARCHBAR, "searchbar");
$tpl->dyn_clear("serow1");
$tpl->dyn_clear("serow2");
$tpl->clear(array("L_CAT","L_COUNT","L_ALL_CAT","L_THIS_CAT","L_SEARCH","CATANUM","COUNT","CATPATH" ));

}

//======================================
// Get Top search keyword
//======================================

function show_tkword($number)
{
	global $l_tkword,$tpl ,$db;
	
	$tpl->define(array( tkblock	=>	 "topkword_small.html" ));
	$tpl->dyn_define ( "tkcol", "tkblock" );

	if (!$number) $number = 5;
	$db->query("select count(kword) as count,kword from LINKER_TWORD 
	group by kword order by count desc,kword limit $number");
	
	$tpl->assign(array( "L_TKWORD" => $l_tkword ));

	while ($row = $db->nrecord()) {
	$tpl->assign(array( T_KWORD => htmlspecial($row[kword]) ));
	$tpl->parse("TROW",".tkcol");
	}
	
	$tpl->assign( array( L_TKWORD	=> $l_tkword, TK_NUM => $number ));
	$tpl->parse(TKBLOCK, "tkblock");
	$tpl->clear(array("TROW","T_KWORD","L_TKWORD","TK_NUM"));
	$tpl->dyn_clear("tkcol");

}

//======================================
// Order parse
//======================================

function show_order() {

global  $tpl,$l_s_array,$u_user1,$u_user2,$u_user3,$u_user4,$u_user5;

$tpl->define(	array( search_form => "order_sbar.html" ));
$tpl->dyn_define ( "seform", "search_form" );

$tpl->assign(array(
L_SEARCH_RESULT => $l_s_array[result],
L_SEARCH_NUM		=> $l_s_array[num],
L_TITLE					=> $l_s_array[title],
L_NAME					=> $l_s_array[name],
L_EMAIL					=> $l_s_array[email],
L_SCONT				=> $l_s_array[scont],
L_COUNT				=> $l_s_array[counter],
L_VISIT					=> $l_s_array[visit],
L_UPTIME				=> $l_s_array[uptime],
L_ASC_ORDER		=> $l_s_array[ascorder],
L_DESC_ORDER		=> $l_s_array[descorder],
L_SORT					=> $l_s_array[sortinput]
));

for ($k=1 ;$k<=5 ;$k++) {
$u_name = ${"u_user" . $k};
$u_fname = "user". $k;

	if($u_name) {
	$tpl->assign( array(SE_NAME	=> $u_name, SE_RNAME	=> $u_fname ));
	$tpl->parse("SEFORM", ".seform");
	}
}

$tpl->parse(ORDERFORM,"search_form");
$tpl->dyn_clear("seform");
$tpl->clear(array("L_SEARCH_RESULT","L_SEARCH_NUM","L_TITLE","L_NAME","L_EMAIL",
"L_SCONT", "L_COUNT","L_VISIT","L_UPTIME","L_ASC_ORDER","L_DESC_ORDER","L_SORT" ));
}

//======================================
// LINK Order parse
//======================================

function show_linkbar() {

global  $tpl,$l_s_array,$l_link,$TotalLink, $u_user1,$u_user2,$u_user3,$u_user4,$u_user5;

$tpl->define(	array( linkbar => "link_bar.html" ));
$tpl->dyn_define ( "orform", "linkbar" );

$tpl->assign(array(
L_SEARCH_RESULT => $l_s_array[result],
L_SEARCH_NUM		=> $l_s_array[num],
L_TITLE					=> $l_s_array[title],
L_NAME					=> $l_s_array[name],
L_EMAIL					=> $l_s_array[email],
L_SCONT				=> $l_s_array[scont],
L_COUNT				=> $l_s_array[counter],
L_VISIT					=> $l_s_array[visit],
L_UPTIME				=> $l_s_array[uptime],
L_ASC_ORDER		=> $l_s_array[ascorder],
L_DESC_ORDER		=> $l_s_array[descorder],
L_SORT					=> $l_s_array[sortinput],
L_LINK					=> $l_link,
LINKNUM	 				=> $TotalLink,
));

for ($k=1 ;$k<=5 ;$k++) {
$u_name = ${"u_user" . $k};
$u_fname = "user". $k;

	if($u_name) {
	$tpl->assign( array(OR_NAME	=> $u_name, OR_RNAME	=> $u_fname ));
	$tpl->parse("ORROW", ".orform");
	}
}

$tpl->parse(LINKBAR,"linkbar");
$tpl->dyn_clear("orform");
$tpl->clear(array("L_SEARCH_RESULT","L_SEARCH_NUM","L_TITLE","L_NAME","L_EMAIL",
"L_SCONT", "L_COUNT","L_VISIT","L_UPTIME","L_ASC_ORDER","L_DESC_ORDER","L_SORT","ORROW",
"L_LINK","LINKNUM"));
}

//======================================
// Order parse
//======================================

function show_norder($order_file,$l_order_name) {

global  $tpl,$l_s_array,$TotalLink,$l_num,$u_user1,$u_user2,$u_user3,$u_user4,$u_user5;

$tpl->define(	array( order_form => "order_nbar.html" ));
$tpl->dyn_define ( "orform", "order_form" );

$tpl->assign(array(
L_ORDER_NAME	=> $l_order_name,
L_NUM				=> $l_num,
L_TITLE				=> $l_s_array[title],
L_NAME				=> $l_s_array[name],
L_EMAIL				=> $l_s_array[email],
L_SCONT			=> $l_s_array[scont],
L_COUNT			=> $l_s_array[counter],
L_VISIT				=> $l_s_array[visit],
L_UPTIME			=> $l_s_array[uptime],
L_ASC_ORDER	=> $l_s_array[ascorder],
L_DESC_ORDER	=> $l_s_array[descorder],
L_SORT				=> $l_s_array[sortinput],
ORDER_FILE		=> $order_file,
SNUM => $TotalLink
));

for ($k=1 ;$k<=5 ;$k++) {
$u_name = ${"u_user" . $k};
$u_fname = "user". $k;

	if($u_name) {
	$tpl->assign( array(SE_NAME	=> $u_name, SE_RNAME	=> $u_fname ));
	$tpl->parse("ORROW", ".orform");
	}
}

$tpl->parse(ORDERFORM,"order_form");
$tpl->dyn_clear("orform");
$tpl->clear(array("L_SEARCH_RESULT","L_SEARCH_NUM","L_TITLE","L_NAME","L_EMAIL",
"L_SCONT", "L_COUNT","L_VISIT","L_UPTIME","L_ASC_ORDER","L_DESC_ORDER","L_SORT","ORROW" ));
}

//======================================
// Mailling list
//======================================

function show_mailling() {

global  $tpl,$l_mailling,$l_join,$l_out,$l_submit;

$tpl->define( array( mailform => "mail_small.html" ));

$tpl->assign(array(
L_MAILLING => $l_mailling,
L_JOIN	=> $l_join,
L_OUT	=> $l_out,
L_SUBMIT	=> $l_submit
));

$tpl->parse(MAILLING, "mailform");
$tpl->clear(array("L_MAILLING","L_JOIN","L_OUT","L_SUBMIT" ));

}


//======================================
// Link template assign
//======================================

function link_assign() {

global $tpl,$l_l_array;

$tpl->assign(array(
L_REVIEW		=> $l_l_array[lcont],
L_VOTE			=> $l_l_array[vote],
L_COUNT		=> $l_l_array[counter],
L_VISIT			=> $l_l_array[visit],
L_VOTE_NUM => $l_l_array[vote_num],
L_COMMENT => $l_l_array[comment],
L_VOTE_AVE =>$l_l_array[vote_ave],
L_UPTIME		=> $l_l_array[uptime]
));

}

function link_unassign() {

global $tpl ;
$tpl->clear(array("L_REVIEW","L_VOTE","L_COUNT","L_VISIT","L_VOTE_NUM","L_COMMENT","L_VOTE_AVE","L_UPTIME" ));
}


//======================================
// Make LINK
//======================================

function  view_link($row,$string="",$prow="") {

global $Sdomain, $Stemplate ,$Ssepchar, $Sarrow, $Sfupload, $Scool_num, $tpl, $c_highpre, $c_highnext,$l_file;

$row[title]=htmlspecial(stripslashes($row[title]));
$row[scont]=htmlspecial(stripslashes($row[scont]));
$row[user1]=htmlspecial(stripslashes($row[user1]));
$row[user2]=htmlspecial(stripslashes($row[user2]));
$row[user3]=htmlspecial(stripslashes($row[user3]));
$row[user4]=htmlspecial(stripslashes($row[user4]));
$row[user5]=htmlspecial(stripslashes($row[user5]));

$interval =ceil(( time() - $row[uptime])/86400);
$date = date("Y-m-d",$row[uptime]);
if ($interval<=1) $mark="<img src='$Sdomain/$Stemplate/image/new_1.gif'>";	
elseif ($interval<=3) $mark="<img src='$Sdomain/$Stemplate/image/new_3.gif'>";
elseif ($interval<=7) $mark="<img src='$Sdomain/$Stemplate/image/new_7.gif'>";

if ($row[c_pick]) $choice="<img src='$Sdomain/$Stemplate/image/choice.gif'>";
if ($row[count]>$Scool_num) $cool="<img src='$Sdomain/$Stemplate/image/cool.gif'>";


// average and total sum

for ($i=1; $i<=10 ;$i++) {
$vnum = "n".$i;
$vote +=$row[$vnum];
$total_sum += $i * $row[$vnum];
}

$temp_evere = ($vote)  ? $total_sum / $vote : 0 ;
$evere = number_format($temp_evere , 2);


// file upload

if ($Sfupload) {
$upfile = @unserialize(stripslashes($row[upfile]));
if (is_array($upfile)) 
$tpl->assign(array(
DOWN	=> "<a href='$Sdomain/download.php?sid=$row[sid]' title='$upfile[0] ($upfile[2])'><img src='$Stemplate/image/file.gif' border=0   align=absmiddle></a>",
FIMGNAME	=>$upfile[1] ));
}

// parent view
if ($prow) {
$path_ar = explode("/",$row[path]);
$txt_ar = explode($Ssepchar,$row[pathtxt]);

for ($i=0 ; $i <count($path_ar) ; $i++) 	{
$link_herear[] = "<a href='index.php?cat=$path_ar[$i]'><font color=gray class=midsmall>$txt_ar[$i]</font></a>";
}

$link_here = @implode($Sarrow,$link_herear);
}
// USER search keyword highlight
if ($string) {
$row[title] = str_replace($string, $c_highpre.$string.$c_highnext , $row[title]);
$row[scont] = str_replace($string, $c_highpre.$string.$c_highnext , $row[scont]);
$row[url] = str_replace($string, $c_highpre.$string.$c_highnext , $row[url]);
}


$tpl->assign(array(
MARK				=> $mark,
CHOICE				=> $choice,
COOL				=> $cool,
LINK_NO			=> $row[sid],
LINK_TITLE		=> $row[title],
LINK_HERE		=> $link_here,
LINK_VOTE		=> $vote,
LINK_COM			=> $row[comment],
LINNK_EVOTE	=> $evere,
LINK_COUNT		=> $row[count],
LINK_VISIT	 		=> $row[visit],
LINK_SCONT		=> $row[scont],
LINK_UPTIME		=> $date,
LINK_URL			=> $row[url],
LINK_USER1		=> $row[user1],
LINK_USER2		=> $row[user2],
LINK_USER3		=> $row[user3],
LINK_USER4		=> $row[user4],
LINK_USER5		=> $row[user5]
));

$tpl->parse("TEMPLINK","link_row");
$link = $tpl->simfetch("TEMPLINK");
$tpl->clear(array("TEMPLINK","DOWN","FIMGNAME"));

return $link;
}


//======================================
// Make Comment
//======================================

function  view_comment($row) {

global $Sdomain, $Stemplate , $tpl;


$row[name] = htmlspecial($row[name]);
$row[content] = htmlspecial($row[content]);

// make start image
for ($i=0;$i< floor($row[vote]/2);$i++) 
$com_star .= "<img src='$Sdomain/$Stemplate/image/star.gif' border=0 width=16 height=16>";

if ($row[vote]%2) 
$com_star .= "<img src='$Sdomain/$Stemplate/image/half_star.gif' border=0>";

if ($row[email]) $row[email] = "<a href='mailto:{$row[email]}'>$row[email]</a>";
if ($row[home]) $row[home] = "<a href='$row[home]' target='_new'>$row[home]</a>";

$row[content]=nl2br(htmlspecial(stripslashes($row[content])));
$date = date("Y/m/d",$row[uptime]);
$tpl->assign(array(
COM_SID			=> $row[sid],
COM_NAME		=> $row[name],
COM_IP				=> $row[ipaddr],
COM_STAR		=> $com_star,
COM_DATE		=> $date,
COM_CONTENT	=> $row[content]
));

$tpl->parse(T_COM,"comment");
$link = $tpl->simfetch("T_COM");
$tpl->clear("T_COM");
return $link;

}

//======================================
// URL Live check
//======================================

function url_live($url)  
{

// 000 : only http://
// 001 checkdnsrr error
// 002 fsockopen error
// other : http return code

if ($url == "http://") return "000";
$parsed = parse_url($url); 
$host = $parsed["host"];
$path = $parsed["path"];

if (!$path) $path = "/";


if (!(checkdnsrr($host,"A"))) return "001";

$fp = fsockopen ("$host", 80, &$errnr, &$errstr) ;
if (!$fp) return "002";

fputs($fp,"GET $path HTTP/1.0\n\n");  

$line = fgets($fp, 1024);  
	 
	 if (eregi( "^http/[0-9]+.[0-9]+ ([0-9]{3}) [a-z ]*", $line)) {
	 $return =   trim(eregi_replace( "^http/[0-9]+.[0-9]+ ([0-9]{3}) [a-z ]*",  "\\1", $line));
	}
	else 	{
	$return = "000";
	}

fclose($fp);  
return $return;
}  


//======================================
// Send mail
//======================================

function send_mail($to,$sub,$mail_body,$html="") {

global $Sadmin_mail,$Scharset, $Ssite_name;

$sub=stripslashes($sub);
$mailbody .= stripslashes($mail_body) . "\n\n";
if ($html) $mailheaders .= "Content-Type: text/html; charset=$Scharset\n";
else $mailheaders .= "Content-Type: text/plain; charset=$Scharset\n";
//$mailheaders .= "Content-Transfer Encoding: 8bit\n";
$mailheaders .= "From: $Ssite_name Administrator<".$Sadmin_mail.">\n";
$mailheaders .= "Reply-To: $Sadmin_mail"."\n";
$mailheaders .= "X-Mailer: LINKER_MAILER";
@mail($to,$sub,$mailbody,$mailheaders);
}    


?>